commit:     074bfb4d09c4c052fed0da22b04948050818b838
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Fri Jul 30 13:51:38 2021 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Fri Jul 30 18:14:13 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=074bfb4d

dev-python/pypy3-exe: Bump to 7.3.5

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 dev-python/pypy3-exe/Manifest               |   2 +
 dev-python/pypy3-exe/pypy3-exe-7.3.5.ebuild | 167 ++++++++++++++++++++++++++++
 2 files changed, 169 insertions(+)

diff --git a/dev-python/pypy3-exe/Manifest b/dev-python/pypy3-exe/Manifest
index 6d7eecda906..0d154c1abd8 100644
--- a/dev-python/pypy3-exe/Manifest
+++ b/dev-python/pypy3-exe/Manifest
@@ -1,4 +1,6 @@
 DIST pypy3.7-gentoo-patches-7.3.4.tar.xz 8464 BLAKE2B 
6d458a41e87eabeb2920b28752fe5cc49bbfc9c5f03d2fc1321362fbd02e9dfb3b41c99cb765b7f2644b9c49c5c60f879ad1c60a66bc991462edb50215b1802d
 SHA512 
1282cf2fa9054209ceb5a91e0b4adcd86de33a326230fabe154b572d5e798d81e93d136e815f1c2816fbfdd5071fcfc175585d4fa5ae93145938bb4cf1d2baa7
+DIST pypy3.7-gentoo-patches-7.3.5.tar.xz 8164 BLAKE2B 
0f8707fda16c0358c1d3a2a60d83046bc5c6186906e07d0e2441d26da4c5d2e7978aa9013be211daf0a1bfddbb10f96745ba4be84b61903e177f4d906045ed67
 SHA512 
95d3acb11c811e4342ba3a56e925433614c5affb6a1fc873ecd2f2cfd55459424088b928f46bcb9a6f0e467fb77905af387ad04bad45a37b928fe0ea320ac33e
 DIST pypy3.7-gentoo-patches-7.3.5rc3.tar.xz 4872 BLAKE2B 
15970c21eb209407af5234719755dd5ddfce95f5b7dd5d525126045d71a00f22d56f26e54a85b94e54dd286334a39cb08abf681e56d466547be206322cf319ac
 SHA512 
4a946560daaba8214f3f5cf828128293bc9aa0eec7d0000e184b3791165f255a7169ee63f9a569a1faed9e8095f593ac7982d49a07f93e085b41be50b275ce3f
 DIST pypy3.7-v7.3.4-src.tar.bz2 25344083 BLAKE2B 
e88dd0cfcc6123dbf894f603162ebe43675c96b992d15c29e14a611a166b8da8d1d2f3298e65e5794b295215440cb88f31d252fcdaef1a0dab52777c24212a49
 SHA512 
c570d34f284f41dcd8dd909216c69831dd83b8501423c7635a4fe506fb16fd3705cf87975a664735e52d0b805a0432267d611a993437d17aac3defe4b9ea4401
+DIST pypy3.7-v7.3.5-src.tar.bz2 25350766 BLAKE2B 
34d5c83284271b184f71492dbd65b8760cc0fcdec71e41ef48b9561280dd67ef4c37fdd70759d0b95114d127446fc0ea5d04feb99022c1a725233862b2028834
 SHA512 
253d2efc81d55fb392ab810741e3a633f664e1908b2c26db7a8830c971655cca6be1b8d34581d13aa2d738a4a4c8ba23c2c90333b6e03d4608372e8013ea723b
 DIST pypy3.7-v7.3.5rc3-src.tar.bz2 25255084 BLAKE2B 
10a7c6c9879b2956726e9457e6939cf7597136dcc54bd8d6c20311468ed622697c151fb6209d49fda21e0710d0c3d18f702f43b01720341b7967663b007b1f09
 SHA512 
6ec569cf80741a540f39687e3cc1c4bf18c4cd038ed1b0782a333ab03e5f85ca221e3af4549d2332c78fcab5a430bd59a5ab14f9fa333624f6f1b9441049b5c3

diff --git a/dev-python/pypy3-exe/pypy3-exe-7.3.5.ebuild 
b/dev-python/pypy3-exe/pypy3-exe-7.3.5.ebuild
new file mode 100644
index 00000000000..70dd2bacbc8
--- /dev/null
+++ b/dev-python/pypy3-exe/pypy3-exe-7.3.5.ebuild
@@ -0,0 +1,167 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+# pypy3 needs to be built using python 2
+PYTHON_COMPAT=( python2_7 )
+inherit check-reqs pax-utils python-any-r1 toolchain-funcs
+
+PYPY_PV=${PV%_p*}
+MY_P=pypy3.7-v${PYPY_PV/_}
+PATCHSET="pypy3.7-gentoo-patches-${PV/_}"
+
+DESCRIPTION="PyPy3 executable (build from source)"
+HOMEPAGE="https://www.pypy.org/";
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2
+       https://dev.gentoo.org/~mgorny/dist/python/${PATCHSET}.tar.xz";
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+SLOT="${PYPY_PV}"
+KEYWORDS=""
+IUSE="bzip2 +jit low-memory ncurses cpu_flags_x86_sse2"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0=
+       dev-libs/libffi:0=
+       virtual/libintl:0=
+       dev-libs/expat:0=
+       bzip2? ( app-arch/bzip2:0= )
+       ncurses? ( sys-libs/ncurses:0= )
+       !dev-python/pypy3-exe-bin:${PYPY_PV}"
+DEPEND="${RDEPEND}"
+BDEPEND="
+       low-memory? ( dev-python/pypy )
+       !low-memory? (
+               || (
+                       dev-python/pypy
+                       dev-lang/python:2.7
+               )
+       )"
+
+check_env() {
+       if use low-memory; then
+               CHECKREQS_MEMORY="1750M"
+               use amd64 && CHECKREQS_MEMORY="3500M"
+       else
+               CHECKREQS_MEMORY="3G"
+               use amd64 && CHECKREQS_MEMORY="6G"
+       fi
+
+       check-reqs_pkg_pretend
+}
+
+pkg_pretend() {
+       [[ ${MERGE_TYPE} != binary ]] && check_env
+}
+
+pkg_setup() {
+       if [[ ${MERGE_TYPE} != binary ]]; then
+               check_env
+
+               # unset to allow forcing pypy below :)
+               use low-memory && EPYTHON=
+               if [[ ! ${EPYTHON} || ${EPYTHON} == pypy ]] &&
+                               { has_version -b dev-python/pypy ||
+                               has_version -b dev-python/pypy-bin; }
+               then
+                       einfo "Using PyPy to perform the translation."
+                       EPYTHON=pypy
+               else
+                       einfo "Using ${EPYTHON:-python2} to perform the 
translation. Please note that upstream"
+                       einfo "recommends using PyPy for that. If you wish to 
do so, please install"
+                       einfo "dev-python/pypy and ensure that EPYTHON variable 
is unset."
+                       python-any-r1_pkg_setup
+               fi
+       fi
+}
+
+src_prepare() {
+       local PATCHES=(
+               "${WORKDIR}/${PATCHSET}"
+       )
+       default
+}
+
+src_configure() {
+       tc-export CC
+
+       local jit_backend
+       if use jit; then
+               jit_backend='--jit-backend='
+
+               # We only need the explicit sse2 switch for x86.
+               # On other arches we can rely on autodetection which uses
+               # compiler macros. Plus, --jit-backend= doesn't accept all
+               # the modern values...
+
+               if use x86; then
+                       if use cpu_flags_x86_sse2; then
+                               jit_backend+=x86
+                       else
+                               jit_backend+=x86-without-sse2
+                       fi
+               else
+                       jit_backend+=auto
+               fi
+       fi
+
+       local args=(
+               --no-shared
+               $(usex jit -Ojit -O2)
+
+               ${jit_backend}
+
+               pypy/goal/targetpypystandalone
+       )
+
+       # Avoid linking against libraries disabled by use flags
+       local opts=(
+               bzip2:bz2
+               ncurses:_minimal_curses
+       )
+
+       local opt
+       for opt in "${opts[@]}"; do
+               local flag=${opt%:*}
+               local mod=${opt#*:}
+
+               args+=(
+                       $(usex ${flag} --withmod --withoutmod)-${mod}
+               )
+       done
+
+       local interp=( "${EPYTHON}" )
+       if use low-memory; then
+               interp=( env PYPY_GC_MAX_DELTA=200MB
+                       "${EPYTHON}" --jit loop_longevity=300 )
+       fi
+
+       if [[ ${EPYTHON} != pypy ]]; then
+               # reuse bundled pycparser to avoid external dep
+               mkdir -p "${T}"/pymod/cffi || die
+               : > "${T}"/pymod/cffi/__init__.py || die
+               cp -r lib_pypy/cffi/_pycparser "${T}"/pymod/cffi/ || die
+               local -x PYTHONPATH=${T}/pymod:${PYTHONPATH}
+       fi
+
+       # translate into the C sources
+       # we're going to build them ourselves since otherwise pypy does not
+       # free up the unneeded memory before spawning the compiler
+       set -- "${interp[@]}" rpython/bin/rpython --batch --source "${args[@]}"
+       echo -e "\033[1m${@}\033[0m"
+       "${@}" || die "translation failed"
+}
+
+src_compile() {
+       emake -C "${T}"/usession*-0/testing_1
+}
+
+src_install() {
+       local dest=/usr/lib/pypy3.7
+       exeinto "${dest}"
+       newexe "${T}"/usession*-0/testing_1/pypy3-c pypy3-c-${PYPY_PV}
+       insinto "${dest}"/include/${PYPY_PV}
+       doins include/pypy_*
+       pax-mark m "${ED}${dest}/pypy3-c-${PYPY_PV}"
+}

Reply via email to